

!!! Listing 1: TalkGui

import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;

public class TalkGui extends Applet
{
   Label         ueb_la;            // Label fuer die Ueberschrift

   Panel         l_pa;              // Container links
   List          li;                // Liste
   Button        verbinden_pb;      // Button
   Button        beenden_pb;        // Button

   Panel         r_pa;              // Container rechts
   Label         partner_la;        // Label fuer Partner
   TextArea      talk_ta;           // Mehrzeiliges Textfeld (Ausgaben) 
   Label         eingabe_la;        // Label fuer Login-Name
   TextField     eingabe_tf;        // Einzeiliges Textfeld (Eingaben)

   TextArea      meldungen_ta;      // Mehrzeiliges Textfeld (Meldungen)

   Panel         login_pa;          // "Box" zum "Anmelden" ins Applet
   Panel         login_rahmen_pa;   // innerer Rahmen in der Maske "Anmelden"
   TextField     name_tf;           // Einzeiliges Textfeld
   Button        anmelden_pb;      // Button
    

   // Layout manager fuer die Container
   GridBagLayout gb = new GridBagLayout();
    
   public void init()
   {
      ueb_la = new Label("Talk, Beispiel fr Java-Tutorial in der iX",
                         Label.CENTER);
      ueb_la.setFont(new Font("Helvetica", Font.BOLD + Font.ITALIC, 16));
      ueb_la.setBackground(Color.lightGray);

      this.setBackground(Color.blue);

      // Generieren der Liste
      li = new List(5, true);
      li.setMultipleSelections(false);
     
      // Generieren eines "Verbinden"-Buttons 
      verbinden_pb = new Button("Verbinden");

      // Generieren eines "Beenden"-Buttons 
      beenden_pb = new Button("Verbindung lsen");
      beenden_pb.disable();

      // Label fuer Partner
      partner_la = new Label("Partner noch nicht ausgewhlt:");
        
      // Generieren eines mehrzeiligen Textfeldes fuer die Eingaben des Partners
      talk_ta =  new TextArea();
      talk_ta.setEditable(false);

      // Label fuer Login-Name
      eingabe_la = new Label("Name noch nicht ausgewhlt:");

      // Generieren eines Textfelds fuer die eigenen Eingaben
      eingabe_tf =  new TextField();

      // Generieren eines mehrzeiligen Textfeldes fuer die Meldungen
      meldungen_ta =  new TextArea(3, 80);
      meldungen_ta.setBackground(Color.lightGray);
      meldungen_ta.setEditable(false);
        
      // Generieren eines Panels an der linken Seite des Windows
      // mit GridBagLayout 
      l_pa = new Panel();
      l_pa.setLayout(gb);
      l_pa.setBackground(Color.lightGray);
       
      // Positionieren der GUI-Komponenten 
      constrain(l_pa, new Label("Teilnehmer:"), 0, 0, 1, 1);
      constrain(l_pa, li, 0, 1, 1, 1, GridBagConstraints.VERTICAL,
                GridBagConstraints.NORTHWEST, 0.0, 1.0, 0, 4, 0, 4);
      constrain(l_pa, verbinden_pb, 0, 2, 1, 1, GridBagConstraints.HORIZONTAL,
                GridBagConstraints.NORTH, 1.0, 0.0, 6, 4, 0, 4);
      constrain(l_pa, beenden_pb, 0, 3, 1, 1, GridBagConstraints.HORIZONTAL,
                GridBagConstraints.NORTH, 1.0, 0.0, 9, 4, 4, 4);
        
      // Generieren des Panels an der rechten Seite des Windows
      // mit GridBagLayout 
      r_pa = new Panel();
      r_pa.setLayout(gb);
      r_pa.setBackground(Color.lightGray);
        
      constrain(r_pa, partner_la, 0, 0, 1, 1);
      constrain(r_pa, talk_ta, 0, 1, 1, 1, GridBagConstraints.BOTH,
                GridBagConstraints.NORTH, 1.0, 1.0, 0, 4, 0, 4);
      constrain(r_pa, eingabe_la, 0, 2, 1, 1);
      constrain(r_pa, eingabe_tf, 0, 3, 1, 1, GridBagConstraints.BOTH,
                GridBagConstraints.NORTH, 1.0, 0.0, 0, 4, 0, 4);

      // Generieren des Panels fuer das "Anmelde"-Fenster
      // dieses Panel spannt den Bereich auf zwischen Ueberschrift und
      // Meldezeile
      login_pa = new Panel();
      login_pa.setLayout(gb);
      login_pa.setBackground(Color.lightGray);

      // Noch ein Panel fuer den Rahmen um die Eingabeelemente
      login_rahmen_pa = new Panel();
      login_rahmen_pa.setLayout(gb);
      login_rahmen_pa.setBackground(Color.white);
      constrain(login_pa, login_rahmen_pa, 0, 0, 1, 1);

      // Einzeiliger Text fuer den Namen des "Talk"-Teilnehmers
      name_tf = new TextField(18);

      // "Anmelden"-Button
      anmelden_pb = new Button("OK");

      constrain(login_rahmen_pa, new Label("Anmelden zum Talk (im Applet) ...",
                Label.CENTER),
                0, 0, 2, 1,
                GridBagConstraints.HORIZONTAL,
                GridBagConstraints.NORTHWEST, 1.0, 1.0, 2, 2, 2, 2);
      constrain(login_rahmen_pa, new Label("Name:"),
                0, 1, 1, 1);
      constrain(login_rahmen_pa, name_tf, 1, 1, 1, 1);
      constrain(login_rahmen_pa, anmelden_pb, 0, 2, 2, 1,
                GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER,
                1.0, 1.0, 2, 2, 2, 2);

      // Nochmal GridBagLayout um wiederum die Panels zu positionieren
      this.setLayout(gb);
      // Die Raender hier sind fuer die blauen Rahmen
      constrain(this, ueb_la, 0, 0, 2, 1, GridBagConstraints.BOTH,
                GridBagConstraints.CENTER, 0.0, 0.0, 2, 2, 0, 2);

      // Die anderen Panels nicht einblenden, weil beim Start zuerst das
      // Fenster zum "Anmelden" gebraucht wird

      constrain(this, login_pa, 0, 1, 2, 1, GridBagConstraints.BOTH,
                GridBagConstraints.NORTHWEST, 1.0, 1.0, 2, 2, 0, 2);

      constrain(this, meldungen_ta, 0, 2, 2, 1, GridBagConstraints.HORIZONTAL,
                GridBagConstraints.NORTHWEST, 1.0, 0.0, 0, 2, 2, 2);
   } /* TalkGui */
    
   public void constrain(Container container, Component component, 
                         int grid_x, int grid_y,
                         int grid_width, int grid_height,
                         int fill, int anchor, double weight_x, double weight_y,
                         int top, int left, int bottom, int right)
   {
      GridBagConstraints c = new GridBagConstraints();
      c.gridx = grid_x;
      c.gridy = grid_y;
      c.gridwidth = grid_width;
      c.gridheight = grid_height;
      c.fill = fill;
      c.anchor = anchor;
      c.weightx = weight_x;
      c.weighty = weight_y;
      if (top+bottom+left+right > 0)
        c.insets = new Insets(top, left, bottom, right);
        
      ((GridBagLayout)container.getLayout()).setConstraints(component, c);
      container.add(component);
   } /* constrain */
    
   public void constrain(Container container, Component component, 
                         int grid_x, int grid_y,
                         int grid_width, int grid_height)
   {
      constrain(container, component, grid_x, grid_y, 
                grid_width, grid_height, GridBagConstraints.NONE, 
                GridBagConstraints.NORTHWEST, 0.0, 0.0, 1, 4, 1, 4);
   } /* constrain */

   public void show_talk()
   {
      constrain(this, l_pa, 0, 1, 1, 1, GridBagConstraints.VERTICAL,
                GridBagConstraints.NORTHWEST, 0.0, 1.0, 2, 2, 0, 0);
      constrain(this, r_pa, 1, 1, 1, 1, GridBagConstraints.BOTH,
                GridBagConstraints.NORTHWEST, 1.0, 1.0, 2, 0, 0, 2);
      this.remove(login_pa);
      // Hier erfolgt leider kein automatischer Update, deshalb, workaround:
      this.resize(401, 401);
      // Das muss noch verbessert werden: Zuerst die akt. Groesse abfragen
      // und verwenden, mit java1.0 scheint es keine Alternative zu geben
   } // show_talk
} // TalkGui

!!! Ende Listing 1: TalkGui

!!! Listing 2: TalkDialog

import java.applet.*;
import java.awt.*;
import java.io.*;
import java.net.*;

public class TalkDialog extends TalkGui
{
   String name = "";
   String partner = "";

   public final static int PORT = 6789;
   Socket s;
   DataInputStream in;
   PrintStream out;
   Zuhoerer zuhoerer;

   // Generiert einen Socket, um mit dem Server ueber Port 6789 einen
   // Kontakt herzustellen.
   // Und zwar auf dem Rechner, auf dem sich der Code
   // des Applets befindet.
   // Ein Thread wird verwendet, um auf die Rueckmeldungen des Servers
   // zu warten
   public void init()
   {
      // Die init-Funktion der Superklasse muss aufgerufen werden, sonst fehlt
      // das GUI
      super.init();
      try
      {
         s = new Socket(this.getCodeBase().getHost(), PORT);
         in = new DataInputStream(s.getInputStream());
         out = new PrintStream(s.getOutputStream());
 
         zuhoerer = new Zuhoerer(in, meldungen_ta, li, talk_ta, partner_la,
                                 beenden_pb, verbinden_pb, eingabe_tf);
 
         this.showStatus("Connected to "
                   + s.getInetAddress().getHostName()
                   + ":" + s.getPort());
      }
      catch (IOException e) this.showStatus(e.toString());
   } // init

   // Diese Methode behandelt alle Action-Events des GUI
   public boolean action(Event event, Object object)
   {
      char c;

      // Mit "target" bekommt man die GUI-Komponente, 
      // die das Event ausgeloest hat.
      if ((event.target == name_tf) | (event.target == anmelden_pb))
      {
         name = name_tf.getText();
         if (name.length() < 3)
         {
            meldungen_ta.appendText("Bitte Name mind. drei Zeichen lang\n");
         }
         else
         {
            zuhoerer.setzeName(name);
            anmelden();
            show_talk();
            eingabe_la.setText(name);
         }
         return true;
      }
      else if (event.target == verbinden_pb)
      {
         if (li.getSelectedIndex() == (-1))
         {
            meldungen_ta.appendText("Bitte Partner auswhlen\n");
         }
         else
         {
            partner = li.getSelectedItem();
            verbinden();
         }
         return true;
      }
      else if (event.target == beenden_pb)
      {
         meldungen_ta.appendText("Verbindung lsen\n");
         partner_la.setText("Partner noch nicht ausgewhlt:");
         beenden_pb.disable();
         verbinden_pb.enable();
         eingabe_tf.disable();
         beenden();
         return true;
      }
      else if (event.target == eingabe_tf)
      {
         senden (eingabe_tf.getText());
         talk_ta.appendText(name + ": " + eingabe_tf.getText() + "\n");
         eingabe_tf.setText("");
         return true;
      }
      meldungen_ta.appendText("Aktion konnte nicht zugeordnet werden\n");
      return false;
   } // action

   void anmelden()
   {
      out.println("A: " + name);
   } // anmelden

   void verbinden()
   {
      out.println("V: " + partner);
   } // verbinden

   void senden(String meldung)
   {
      out.println("S: " + meldung);
   } // senden

   void beenden()
   {
      out.println("B: ");
   } // beenden
   
} // TalkDialog


// Wartet auf Antworten des Servers und zeigt sie entsprechend an.
// Dazu muessen die notwendigen GUI-Komponenten uebergeben werden.

class Zuhoerer extends Thread
{
   DataInputStream in;
   TextArea meldungen_ta;
   List li;
   TextArea talk_ta;
   Label partner_la;
   Button beenden_pb;
   Button verbinden_pb;
   TextField eingabe_tf;
   String name;

   public Zuhoerer(DataInputStream in,
                   TextArea meldungen_ta, List li,
                   TextArea talk_ta, Label partner_la,
                   Button beenden_pb, Button verbinden_pb,
                   TextField eingabe_tf)
   {
      this.in = in;
      this.meldungen_ta = meldungen_ta;
      this.li = li;
      this.talk_ta = talk_ta;
      this.partner_la = partner_la;
      this.beenden_pb = beenden_pb;
      this.verbinden_pb = verbinden_pb;
      this.eingabe_tf = eingabe_tf;
      this.name = name;
      this.start();
   }

   public void run()
   {
      String line;
      String meldung;
      String partner = "";

      try
      {
         for(;;)
         {
            line = in.readLine();
            if (line == null) break;

            // Jetzt die Antwort interpretieren, das ist aehnlich wie beim
            // Server.
            // Es kommen aber noch einige Error-Codes dazu, sie sind durch-
            // numeriert und liefern jeweils eine Meldung zurueck.
            // Die Nachricht "M" ist zum Uebertragen von Meldungen gedacht
            meldung = line.substring(3);
            switch (line.charAt(0))
            {
               case 'A': // Anmelden
                 li.addItem(meldung);
               break;
               case 'V': // Verbinden
                 partner = meldung;
                 partner_la.setText(name + " <--> " + partner);
                 beenden_pb.enable();
                 verbinden_pb.disable();
                 eingabe_tf.enable();
               break;
               case 'S': // Meldung senden
                 talk_ta.appendText(partner + ": " + meldung + "\n");
               break;
               case 'P': // Verbindung von anderem Teilnehmer
                 partner = meldung;
                 partner_la.setText(name + " <--> " + partner);
                 beenden_pb.enable();
                 verbinden_pb.disable();
                 eingabe_tf.enable();
               break;
               case 'B': // Verbindung beenden
                 partner_la.setText("Partner noch nicht ausgewhlt:");
                 beenden_pb.disable();
                 verbinden_pb.enable();
                 eingabe_tf.disable();
               break;
               case 'L': // Teilnehmerliste loeschen
                 li.delItems(0, li.countItems() - 1);
               break;
               case 'M': // Meldung vom Server empfangen
               case '1': // Fehlermeldung vom Server empfangen
                 meldungen_ta.appendText(meldung + "\n");
               break;
               case '2': // Fehlermeldung vom Server empfangen
                 partner_la.setText("Partner noch nicht ausgewhlt:");
                 beenden_pb.disable();
                 verbinden_pb.enable();
                 eingabe_tf.disable();
                 meldungen_ta.appendText(meldung + "\n");
               break;
               default:
               break;
            }
         }
      }
      catch (IOException e) meldungen_ta.appendText(e.toString());
      finally meldungen_ta.appendText("Verbindung zum Server unterbrochen");
   } // run

   void setzeName(String name)
   {
      this.name = name;
   } // setzeName

} // Zuhoerer

!!! Ende Listing 2: TalkDialog

!!! Listing 3: TalkServer

import java.io.*;
import java.net.*;
import java.util.*;

public class TalkServer extends Thread
{
   public final static int DEFAULT_PORT = 6789;
   protected int port;
   protected ServerSocket listen_socket;
   public Vector talk_verbindungen = new Vector();
    
   // Terminiert mit einer Fehlermeldung, falls eine Exception auftritt
   public static void beenden(Exception e, String msg)
   {
      System.err.println(msg + ": " + e);
      System.exit(1);
   } // beenden
    
   // Generiert den Listen-ServerSocket, startet den Thread
   public TalkServer(int port)
   {
      if (port == 0) port = DEFAULT_PORT;
      this.port = port;
      try { listen_socket = new ServerSocket(port); }
      catch (IOException e) beenden(e,
                                  "Exception beim Generieren des ServerSocket");
      System.out.println("Server: auf port " + port);
      this.start();
   } // TalkServer
    
   // Der Thread-Koerper: Endlosschleife, die immer auf Lesen steht und die
   // Verbindung zu den Clients aufbaut. Fuer jede Verbindung wird ein
   // Objekt der Klasse "TalkVerbindung" instantiiert, die die Kommunikation
   // ueber einen neuen Socket abwickelt. Alle Objekte der Klasse TalkVerbindung
   // werden in einen Vektor eingehaengt.
   public void run()
   {
      try
      {
         while(true)
         {
            Socket client_socket = listen_socket.accept();
            TalkVerbindung tv = new TalkVerbindung(client_socket,
                                                   talk_verbindungen);

            talk_verbindungen.addElement(tv);
            System.out.println("Neuer Client angemeldet");
         }
      }
      catch (IOException e) beenden(e,
             "Exception waehrend des listen auf eine neue Verbindung");
   } // run
    
   // Starten des Servers. Geht auf den optional angegebenen Port
   public static void main(String[] args)
   {
      int port = 0;

      if (args.length == 1)
      {
         try port = Integer.parseInt(args[0]); 
         catch (NumberFormatException e) port = 0;
      }
      new TalkServer(port);
   } // main
}

// Diese Klasse behandelt die Kommunikation mit dem Client
class TalkVerbindung extends Thread
{
   protected Socket client;
   protected DataInputStream in;
   protected PrintStream out;

   Vector talk_verbindungen;
   String name = "";
   String partner = "";

   // Initialisieren der Streams und Starten des Threads
   public TalkVerbindung(Socket client_socket, Vector talk_verbindungen)
   {
      this.talk_verbindungen = talk_verbindungen;
      client = client_socket;
      try
      { 
         in = new DataInputStream(client.getInputStream());
         out = new PrintStream(client.getOutputStream());
      }
      catch (IOException e)
      {
         try client.close(); catch (IOException e2);
         System.err.println("Exception waehrend Socket-streams "
                            + "geoeffnet werden: " + e);
         return;
      }
      this.start();
   } // TalkVerbindung
    
   // Macht die Kommunikation, interpretiert die Nachrichten und sendet
   // Antworten zurueck
   public void run()
   {
      String line;
      int i;
      int anz_teilnehmer;
      TalkVerbindung teilnehmer;
      String gew_partner;
      String meldung;

      try
      {
         for(;;)
         {
            // Nachricht lesen
            line = in.readLine();
            if (line == null)
            {
               System.out.println("Verbindung zu " + name + " unterbrochen");
               talk_verbindungen.removeElement(this);
               return;
            }
            System.out.println("<- Meldung: " + line);
            // ... und interpretieren
            switch (line.charAt(0))
            {
               case 'A': // Anmelden
                 name = line.substring(3);
                 // ToDo: Checken, ob dieser Name schon vorkommt, dann Sonder-
                 //       behandlung
                
                 // Als Antwort wird die Teilnehmerliste zurueckgegeben,
                 // der Einfachheit halber jeder Teilnehmer einzeln
                 anz_teilnehmer = talk_verbindungen.size();
                 for (i = 0; i < anz_teilnehmer; i++)
                 {
                    teilnehmer = (TalkVerbindung)talk_verbindungen.elementAt(i);
                    sende("A: " + teilnehmer.gibName());
                 }
                 sende("M: Willkommen zum Talken, " + name + "!");
               break;
               case 'V': // Verbinden
                 gew_partner = line.substring(3);

                 // Checken: Hat der gewuenschte Teilnehmer schon einen
                 //          anderen Gespraechspartner? Wenn ja, Fehlermeldung,
                 //          wenn nein, Partner wechselseitig eintragen
                 anz_teilnehmer = talk_verbindungen.size();
                 for (i = 0; i < anz_teilnehmer; i++)
                 {
                    teilnehmer = (TalkVerbindung)talk_verbindungen.elementAt(i);
                    if (gew_partner.compareTo(teilnehmer.gibName()) == 0)
                    {
                       if (teilnehmer.gibPartner().compareTo("") == 0)
                       {
                          teilnehmer.setzePartner(name);
                          partner = gew_partner;
                          sende("V: " + partner);
                          sende("M: " + "Verbindung zu " + gew_partner +
                                      " hergestellt");
                          teilnehmer.sende("P: " + name);
                          teilnehmer.sende("M: Teilnehmer " + name
                                          + " hat eine Verbindung hergestellt");
                          // ToDo: Teilnehmerlisten an alle neu verteilen
                          break;
                       }
                       else
                       {
                          sende("1: Ihr gewnschter Partner spricht "
                                      + "schon");
                          break;
                       }
                    }
                 }
                 if (i == anz_teilnehmer)
                 {
                    sende("2: Ihr gewnschter Partner hat sich "
                                + "abgemeldet");
                 }
               break;
               case 'S': // Meldung senden
                 meldung = line.substring(3);
                 // Auch hier muss gecheckt werden: Ist der Teilnehmer noch
                 // aktiv?
                 anz_teilnehmer = talk_verbindungen.size();
                 for (i = 0; i < anz_teilnehmer; i++)
                 {
                    teilnehmer = (TalkVerbindung)talk_verbindungen.elementAt(i);
                    if (teilnehmer.gibName().compareTo(partner) == 0)
                    {
                       teilnehmer.sende("S: " + meldung);
                       break;
                    }
                 }
                 if (i == anz_teilnehmer)
                 {
                    sende("2: Ihr gewnschter Partner hat sich "
                                + "abgemeldet");
                 }
               break;
               case 'B': // Verbindung beenden
                 partner = "";
                 anz_teilnehmer = talk_verbindungen.size();
                 for (i = 0; i < anz_teilnehmer; i++)
                 {
                    teilnehmer = (TalkVerbindung)talk_verbindungen.elementAt(i);
                    if (name.compareTo(teilnehmer.gibPartner()) == 0)
                    {
                       teilnehmer.setzePartner("");
                       teilnehmer.sende("B:  ");
                    }
                 }
                 sende("M: Ihr Gesprchspartner hat sich abgemeldet");
               break;
               default:
               break;
            }
         }
      }
      catch (IOException e);
      finally try client.close(); catch (IOException e2);
   } // run

   public String gibName()
   {
      return(name);
   } // gibName

   public String gibPartner()
   {
      return(partner);
   } // gibPartner

   public void setzePartner(String partner)
   {
      this.partner = partner;
   } // setzePartner

   // Fuer alle Nachrichten an einen anderen Teilnehmer
   public void sende(String meldung)
   {
      System.out.println("-> Meldung: " + meldung);
      out.println(meldung);
   } // sende

} // TalkVerbindung

!!! Ende Listing 3: TalkServer

